;**********************************************************************                                                            *
;    Filename:      KP6T1.asm            *
;    Date:  2015.03.01 //Rev.1 2018.05.06(MemoryN̓sǏC)                                                         *
;    File Version:                                          *
; ;	DTSLSI	TC9256PpvO KP6 HF TRXp/ QHFCTRi2003.1.11)  		                                                                  *
;    Author:   jk1xkp                                                     *
;    Company:                                                         *
;                                            
;      QlāF9850_128SG6.asm <SG5; LCD16x2Ή  //SG6;step=20kHzǉ &400k폜> 
;	gp
;	ohb		PIC16F819 iȊOɂp\j
;
;		NbN	NbN 8MHz
;**********************************************************************
;    Notes: 
;1.LCD 13ڂ Eƕ\Ƃ́APLL UnlockBVCObN͈͂H
;2.	EEPROM SAVE ADRESS
;		;#00h   #01h    #02h    #03h	#04h	#05h	#06h	#07h
;		;stROM, vxo,	nr0,	nr1,	Nband- 5Aaddress	
;3.LCD\ʒu
; _  0  7  .  0  5  0  .  0  k  H  z  A  1  L  F
;@L  S  B  _  S  5  0  H  _  R  i  t  +  1  .  3  ;
;4.PIC16F819ĕtAdStep SW(PORTB.6)ȂAdB
;  EEPROM̏ݒ肪Ȃ
;5.dRIT SW(PORTB.7)ȂAdB
;  VXO[h(0-255)ݒ肪Ȃ
;6.TC9256Pgp  Xtal 8MHz  Ref=10kHz,̐ݒB
;7.sATCFidENX^ERgXguq̔z͏ȗj
;		( H:[qopen  L:[q2.4kGRDɗƂ)
;	ohbPUeWPX	
;	()̓sԍ
;	RA7-OSC1(16)		LCD RS	
;	RA6-OSC2(15)		LCD E	

;	RA5-MCL(04)		TX_PTT 		
;	RA4(03)			74HC595P_SCK	
;	RA3(02)			74HC595P_RCK 
;	RA2(01)			TC9256P_PRD
;	RA1(18)			TC9256P_CK	
;	RA0(17)			RIT VR50k
;		LCD SC1602
;	RB7(13)			LCD DB4	=TC9256P_DATA, 74HC595_Ser	    
;	RB6(12)			LCD DB5	
;	RB5(11)			LCD DB6	
;	RB4(10)			LCD DB7 (mode CW,LSB,USB)	
;	RB3(09)					  (mode CW,LSB,USB)
;	RB2(08)			o;TX on /Memory
;	RB1(07)			ENC-A	
;	RB0(06)			ENC-B	
;	GND	=R/~W,D
;				RB4`RB7́@L@xŃ^NgSWm
;umode (lsb,usb,cw)vuBandvustep(50,500Hz)vuRITvuPTTv

;**********************************************************************

	list      p=16f819           ; list directive to define processor
	#include <p16F819.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _WDT_OFF & _PWRTE_ON &_INTRC_IO  

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.

#define		PTT   	PORTA,5		;PTT		
#define		H59   	PORTA,4		;74HC595P_SCK
#define		H59_3  	PORTA,3		;3rd_74HC595P_SCK <Band select>
#define		RCK   	PORTA,2		;74HC595P_RCK
#define		PRD	   	PORTA,2		;TC9256P_PRD 

#define		T56   	PORTA,1		;TC9256P_CK
#define		RIT   	PORTA,0		;RIT VR50k
#define		RS   	PORTA,7		;LCD_RS
#define		E  		PORTA,6		;LCD_E

#define		DAT  	PORTB,7		;Data for TC9256 & 74HC595
#define		H59_2  	PORTB,2		;2nd_74HC595P_SCK <Band select>

;***** VARIABLE DEFINITIONS
VALUE		EQU	H'7A'
scn			EQU	H'7B'	;Bank0-4 
ADDR		EQU	H'7C'
pc_temp		EQU	H'7D'
w_temp		EQU 0x7E        ; variable used for context saving 
status_temp EQU 0x7F        ; variable used for context saving
;   --------------- adress 20&H  
USB0		EQU	0x20	;20hԒn! LCD2sڑ1"USB"\f[^[
USB1		EQU	0x21	;21hԒn! LCD2sڑ2"USB"\f[^[
USB2		EQU	0x22	;22hԒn! LCD2sڑ3"USB"\f[^[
plk			EQU	0x23	;23hԒnif PLL-Lock, then  plk=uLv=04ch, else uUv=055h
s_rit		EQU	0x24	;24hԒnBRIT+(2b )-( 2d)H 	
decrit0		EQU	0x25	;25hԒnBRIT̕΍(100HzP)10iϊBLCD\p
decrit1		EQU	0x26	;26hԒnBRIT̕΍(100HzP
decrit2		EQU	0x27	;27hԒn sgp
dot			EQU	0x28	;28hԒn.RIT\̐Ԃ̃hbg
Dstep0		EQU	0x29	; 50H or 10k	
Dstep1		EQU	0x2a	; 50H or 10k
Dstep2		EQU	0x2b	; 50H or 10k		;;	
stROM		EQU	0x2c	;must be 0x2c/ 
vxo			EQU	0x2d	;VXO(0-200) must be 0x2d-
nr0			EQU	0x2e	;PLL  must be 0x2e-
nr1			EQU	0x2f	;PLL  must be 0x2f-
;   -------------- adress 30&H
Nband		EQU	0x30	;Nband(0-8) must be 0x30		;		
dec0		EQU	0x31	; 10ii[ꏊiPOoCgj
dec1		EQU 0x32    	
dec2		EQU	0x33		
dec3		EQU	0x34		
dec4		EQU	0x35	;10MHz
dec5		EQU	0x36	;1MHz
dec6		EQU	0x37	;100kHz
dec7		EQU	0x38	;10kHz
dec8		EQU	0x39	;1kHz
dec9		EQU	0x3A	;;0.1kHz
O_rit		EQU	0x3B	;;u+v;0<rit<128,, u-v;128rit<255  50HzP
ritSW		EQU	0x3C	;ritSW=1 or 0	
N_rit		EQU	0x3D	;new RIT	
wait_cn		EQU	0x3E		;
wait_cn2	EQU	0x3F		
;    ------------- adress 40&H
val0		EQU	0x40		; ϊliRQrbgj
val1		EQU	0x41
val2		EQU	0x42
val3		EQU	0x43
val_m		EQU	0x44; ꎞ]i[ꏊiTu[`Ŏgpj
y0			EQU	0x45	
y1			EQU	0x46
y2			EQU	0x47
y3			EQU	0x48
step0		EQU	0x49	;;ENCD̎gstep=1(50Hz) or 200(10kHz)
N			EQU	0x4A		
het			EQU	0x4B	;/	up=1; lower=2
temp		EQU	0x4C
ct			EQU	0x4D		;Sub counter
cp			EQU	0x4E	;wait_ routin ŎgĂJE^Bėpgp
cs			EQU	0x4F	;wait_ routin ŎgĂJE^Bėpgp
;    ------------- adress 50&H		
cn			EQU	0x50		;
cf			EQU	0x51		;
old34		EQU	0x52	;;mode(LSB, USB,CW) 
new34		EQU	0x53	; mode(LSB, USB,CW) 
poi			EQU	0x54
x0			EQU	0x55	;
x1			EQU	0x56
x2			EQU	0x57
x3			EQU	0x58
x_m			EQU	0x59	; ꎞ]i[ꏊ(Tu[`Ŏgpj  	
if0			EQU	0x5a	;IFg  IF_tab load
if1			EQU	0x5b
if2			EQU	0x5c
d4			EQU	H'5d'
d8			EQU	H'5e'
reg01		EQU	H'5f'	;Encoder
;    ------------- adress 60&H	
NRb27		EQU	0x60	; ;RB߰Ă̌ݒl bit.7-2
ORb27		EQU	0x61	;ORB߰Ă̒l
old01		EQU	H'62'	; ;RB0,1߰Ẳߋl
new01		EQU	H'63'	; ;RB0,1߰Ă̌ݒl
Tnr0		EQU	H'64'  	;;PLL  RITTX
Tnr1		EQU	H'65'	;;PLL  RITTX
Tvxo		EQU	H'66'  	;;VXO RX
cu			EQU	H'67'	;vxo=vxo+step  Up Carry Flag
cd			EQU	H'68'  	;vxo=vxo-step  Down Carry Flag
;old47		EQU	H'69'	;PORTB.2-7̕ω`FbN
;new47		EQU	H'6a'	;
nr2			EQU	H'6b'	;Ɂ@nr2=0
vfc			EQU	H'6c'	;intrruptuɂ@vfc.0=1
VCOport		EQU	H'6d'	;port=o5/xx/xx/xx/ o4/o3/o2/o1, 0=OFF, 1=Low(ON)
p_chk		EQU	H'6e'	;nr1 ω p_chk=1. if p_chk=1, then call PortChg
temp1		EQU	H'6f'	;
;    ------------- adress 70&H	
VCO_n		EQU	H'70'	;;VCO name ?A/B/C/D
tempend		EQU	H'78' 	;temp Counter
;**********************************************************************
	ORG     0x000             ; processor reset vector

	goto    start              ; go to beginning of program

	ORG     0x004             ; interrupt vector location
isr		;;荞ݏ-routine
i_rb0	movwf	w_temp		;W@File w_tempւ̕ۑ
		swapf	STATUS,0
		clrf	STATUS		;Bank0
		movwf	status_temp	;status@File@̕ۑ
	;	bcf		INTCON,GIE
isr0	;;荞ݏ-routine
		btfss	PTT	;if PTT=ON(L, on TX), then retfie
		goto	pop1
	;	call	readb		;input mode portb
isr1	movf	PORTB,0	
		andlw	B'00000011'	
		movwf	new01

	;	btfss	old01,0	;if old11.rb0=L, then goto pop
	;	goto	pop1

		call	wt255u	;255 usec҂.ݺނ̓,ݸޖh~		
		movf	PORTB,0		
		andlw	B'00000011'	;masking RB0-1
		subwf	new01,0
		btfss	STATUS,Z
		goto	isr1

		btfsc	new01,0	;if new11.rb0=H, then goto pop
		goto	pop1

		goto	encd
	
	;	btfsc	PORTB,0	;Rotary Ecd ;temp
	;	goto	pop1						;temp
encd	btfss	new01,1		;Rb1=HȂ vxo Z
		goto	issub		;vxo=vxo-step0
		;btfss	reg01,1			;Rb.1=LȂΌZ
		goto 	isadd		;vxo=vxo+step0

issub	call	sub_v		;vxo=vxo-step0
		goto	pop
isadd	call 	add_v		;vxo=vxo+step0
		goto	pop

pop		bsf		vfc,0		;vfo change record, vfc=1
pop1	swapf	status_temp,0	;status@File@̖߂
		movwf	STATUS	
		swapf	w_temp,1	;W@File@̖߂
		swapf	w_temp,0
		bcf		INTCON,1	;intcon-INTF(tOj̃Zbg
		bsf		INTCON,GIE 		; Enable INTs.
				
		retfie
;-----------
; remaining code goes here
;--------------------------------------------------------------
VCO_Nr1	addwf	PCL,1  		;;VCO؂ւg'@nr1_H'2100';<84.5MHz-62.8MHz=21.7MHz>
		retlw	H'83'	;if nr1<H'83', the VCO1	for max21.0MHz(H'8300'=33536*10/4 -62825kHz=21,015kHz))
		retlw	H'8d'	;if nr1<H'8d', the VCO2	for max27.4MHz
		retlw	H'98'	;if nr1<H'98', the VCO3for max34.4MHz, else VCO4 	

VCO_set	addwf	PCL,1  		;;VCOݒ;VCOport=o5/xx/xx/xx/ o4/o3/o2/o1, 0=High(OFF), 1=Low(ON)
				;Don't modfy here
		retlw	B'00000000'	;poi=0 VCO1=A	
		retlw	B'00000001'	;poi=1 VCO2=B at OT1=1<Low(ON)>
		retlw	B'00000010'	;poi=2 VCO3=C at OT2=1<Low(ON)>
		retlw	B'00000100'	;poi=3 VCO4=D at OT3=1<Low(ON)>

VCOname	addwf	PCL,1  		;;VCO name ?A/B/C/D@VCO_n@
				;Don't modfy here	
		retlw	H'41'	;;poi=0 VCO1=A
		retlw	H'42'	;;poi=1 VCO2=B
		retlw	H'43'	;;poi=2 VCO3=C 
		retlw	H'44'	;;poi=3	VCO4=D 		

	
tab_dp	addwf	PCL,1  	;f[^7bit=1ƂBAhXf[^͂̂܂

		retlw	H'34'	;poi=0  dec[3]	;u0v
		retlw	H'35'	;poi=1	dec[4]	;u1v 
		retlw	H'36'	;poi=2	dec[5]	;u4v 
		retlw	H'ac'	 	;poi=3	u,vG2ch+80h	 
		retlw	H'37'	;poi=4	dec[6]	;u0v
		retlw	H'38'	;poi=5	dec[7]	;u5v
		retlw	H'39'	;poi=6	dec[8]	;u0v		
		retlw	H'ac'		;poi=7	u,v 
		retlw	H'3a'	;poi=8	dec[9]	;u1v
		retlw	H'eb'		;poi=9	ukv
		retlw	H'c8'		;poi=10	uHv 	 
		retlw	H'fa'		;poi=11	uzv	
		retlw	H'70'	;poi=12	VCOname;; ?A/B/C/D 
		retlw	H'31'	;poi=13	dec[0]	;Nband
		retlw	H'23'		;poi=14	uUv;PLL Lock=L, else U 
		retlw	H'c6'		;poi=15	uFv;46h+80h
;   	ȉ2s
		retlw	H'20'		;poi=16	uU];20hԒnWX^
		retlw	H'21'		;poi=17 uSv
		retlw	H'22'		;poi=18	uBv	 
		retlw	H'a0'		;poi=19	u_v	
		retlw	H'f3'		;poi=20	usv;73h+80h
		retlw	H'29'		;poi=21	u5v
		retlw	H'2a'		;poi=22	u0v 	 
		retlw	H'2b'		;poi=23	uHv;
		retlw	H'a0'		;poi=24	u_v;20h+80h
		retlw	H'd2'		;poi=25	uRv;52h+80h
		retlw	H'f4'		;poi=26	utv;	74h+80h
		retlw	H'a0'		;poi=27	u_v;
		retlw	H'24'		;poi=28	u+/-]	;s_rit;24hԒnBRIT+(2b )-( 2d)
		retlw	H'25'		;poi=29	u1v		;decrit[0]	 
		retlw	H'28'		;poi=30	u.v		;dot	;28hԒn.RIT\̐Ԃ̃hbg
		retlw	H'26'		;poi=31	u2v		;decrit[1]
		nop	

B_data	addwf	PCL,1  	;		;W=Nbanmd// 0=< Nband@<=8
		goto	B_3.5	;Nband=0
		goto	B_7 	;Nband=1
		goto	B_10 	;Nband=2
		goto	B_14 	;Nband=3
		goto	B_18 	;Nband=4
		goto	B_21 	;Nband=5
		goto	B_24  	;Nband=6
		goto	B_28 	;Nband=7
		goto	B_50 	;Nband=8   ;܂Ł@H'0FF'255ȓ
	;-----------
B_3.5 	nop  	;Nband=0	;3.5MHz;PLO=78.366MHz(15.546+62.820)MHz
			;VCO A,B,C,D Iʒux̂߁Anr0, nr1 *S{set
		movlw	H'70'	; 	;=PLLPnm=7836*4=H'7A70'
		movwf	nr0		;RX=7836 x10kHz -(62,820+11,996)=3,549kHz
		movlw	H'7A'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

B_7 	nop  	;Nband=1	;7MHz;PLO=81.86MHz
		movlw	H'E8'	; 	;=PLLPnm=8186*4=H'7FE8'
		movwf	nr0		;RX=8186 x10kHz -(62,820+11,996)=7,044kHz
		movlw	H'7F'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

B_10 	nop 	;Nband=2	;10.1MHz;PLO=84.92MHz
		movlw	H'B0'	; 	;=PLLPnm=8492*4=H'84B0'
		movwf	nr0		;RX=8492 x10kHz -(62,820+11,996)=10,104kHz
		movlw	H'84'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

B_14 	nop  	;Nband=3	;14MHz;PLO=88.86MHz
		movlw	H'D8'	; 	;=PLLPnm=8886*4=H'8AD8'
		movwf	nr0		;RX=8886 x10kHz -(62,820+11,996)=14,044kHz
		movlw	H'8a'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

B_18 	nop  	;Nband=4	;18.1MHz;PLO=92.90MHz
		movlw	H'28'	; 	;=PLLPnm=9290*4=H'9128'
		movwf	nr0		;RX=9290 x10kHz -(62,820+11,996)=18,084kHz
		movlw	H'91'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

B_21 	nop  	;Nband=5	;21MHz;PLO=95.86MHz
		movlw	H'c8'	; 	;=PLLPnm=9586*4=H'95c8'
		movwf	nr0		;RX=9586 x10kHz -(62,820+11,996)=21,044kHz
		movlw	H'95'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

B_24 	nop 	;Nband=6	;24.93MHz;PLO=99.74MHz
		movlw	H'd8'	; 	;=PLLPnm=9974*4=H'9bd8'
		movwf	nr0		;RX=9974 x10kHz -(62,820+11,996)=24,924kHz
		movlw	H'9b'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

B_28 	nop  	;Nband=7	;28MHz;PLO=102.86MHz
		movlw	H'B8'	; 	;=PLLPnm=10286*4=H'A0B8'
		movwf	nr0		;RX=10286 x10kHz -(62,820+11,996)=28,044kHz
		movlw	H'a0'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

B_50 	nop  	;Nband=8	;50MHz;PLO=100.97MHz
		movlw	H'c4'	; 	;=PLLPnm=10097*4=H'9dc4'
		movwf	nr0		;RX=10097 x10kHz -(62,820-11,996)=50,146kHz
		movlw	H'9d'	;
		movwf	nr1
		movlw	D'2'	;if D'2', then Up Hetro
		movwf	het
		return
	;==============

VXOset	; x@ VXO 	;;VXO;100HzPʂVXOgdataށB=10kHz
						;;.VXOmax=62,820.0kHz=H'0995e8' (VCap=0Volt)
		movlw	H'e8'
		movwf	x0		
		movlw	H'95'
		movwf	x1		
		movlw	H'09'
		movwf	x2
		;clrf	x3
		return
		
IFset	btfss	new34,3 ;	;y@IF 100HzPʂŎgdata
		goto	IFcw
		btfss	new34,4
		goto	IFusb
		goto	IFlsb

IFlsb	nop  		;;IF 100HzPʂŎgdata捞.
		movlw	H'9a'		;IFusb=11,996.2kHz=H'01D49a'
		movwf	y0
		movlw	H'D4'
		movwf	y1
		movlw	H'01'
		movwf	y2 
;		clrf	y3
		return

IFusb	nop 		;;IF 100HzPʂŎgdata捞
		movlw	H'B8'		;IFlsb=11,999.2kHz=H'01D4B8'
		movwf	y0
		movlw	H'D4'
		movwf	y1
		movlw	H'01'
		movwf	y2 
		;clrf	y3
		return

IFcw	nop		;;IF 100HzPʂŎgdata捞
		movlw	H'A2'		;IFcw=11,997.0kHz=H'01D4A2'
		movwf	y0
		movlw	H'D4'
		movwf	y1
		movlw	H'01'
		movwf	y2 
		;clrf	y3
		return
;---------------------荞ݏuroutin------------
;-----------------------------------------------------------		
add_v					;15step		
		clrf	cu	;Up Carry Flag
		movlw	D'56'
		addwf	vxo,1	;vxo= vxo+ 56
		movf	step0,0
		addwf	vxo,1	;vxo=vxo+ step0
		btfss	STATUS,C
		bcf		cu,0
		btfsc	STATUS,C
		bsf		cu,0	;vxo=vxo+step  Up Carry Flag// C bitcu.0=1
		
		bcf		STATUS,C
		movlw	D'4'
		btfsc	cu,0	;STATUS,C łCarry̑
		addwf	nr0,1	;nr0= nr0+1
		btfss	STATUS,C
		goto	add_1
		incf	nr1,1
		bsf		p_chk,0	;if nr1 change, then p_chk,0=1

add_1	movlw	D'56'
		btfsc	cu,0	;if cu.0=1, then Carry up,Zsv
		movlw	D'0'						
		subwf	vxo,1	;W= vxo+ (256-56)
		;goto	pop
		return
sub_v				;14step
		clrf	cd	;Down Carry Flag
		movf	step0,0
		subwf	vxo,1	;vxo= vxo+ (256-step0)
		btfss	STATUS,C
		bcf		cd,0
		btfsc	STATUS,C
		bsf		cd,0	;vxo=vxo-step  Down Carry Flag// C bitcd.0=0		

		movlw	D'4'
		btfss	cd,0	;;STATUS,C łCarry̑
		subwf	nr0,1	;nr0= nr0+ (256-1)
		btfsc	STATUS,C
		goto	sub_1
		decf	nr1,1
		bsf		p_chk,0	;if nr1 change, then p_chk,0=1

sub_1	movlw	D'56'
		btfsc	cd,0	;if cd.0=0, then Carry down
		movlw	D'0'						
		subwf	vxo,1	;W= vxo+ (256-56)
		;goto	pop
		return
;----------------
;----------------------------
Adjvxo	bcf		INTCON,7	;荞݋֎~
		clrf	vxo
Adj1	call	readb		;input mode portb
Adj2	movf	PORTB,0	
		andlw	B'00000011'	
		movwf	new01
		
		call	wt5u	;5 usec҂.ݺނ̓,ݸޖh~
		movf	PORTB,0	
		andlw	B'00000011'	
		subwf	new01,0
		btfss	STATUS,Z
		goto	Adj2

Adj4	movf	new01,0		;if old01.0= new01, then goto Adj2
		subwf	old01,0
		btfsc	STATUS,Z
		goto	Adj2
		goto	Adj5

Adj5	btfss	old01,0		;if old01.0= HL,then next step, else goto Adj2(Adj_e)
		goto 	Adj_e
		btfsc	new01,0
		goto 	Adj_e
		goto	encd1

encd1	btfss	new01,1	;Rb1=LȂ vxo Zadd
		goto	Adj_dec	;Sub	VXO=VXO-1
		goto	Adj_add	;Add	VXO=VXO+

Adj_dec	decf	vxo,1		
		goto	Adj9

Adj_add	incf	vxo,1
		goto	Adj9

Adj9	call	Adj595	;74HC595	/come here from start

		movf	vxo,0	
		movwf	val0
		clrf	val1
		clrf	val2
		clrf	val3
		call	dcmain		;16i-10iϊ	/4900step
	;----	call	put chara
		call	writb				;/8step
		movlw	H'80'
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		;-------;;\				
		bsf		RS
		movf	dec7,0
		movwf	d4		
		call	write_lcd4

		movf	dec8,0
		movwf	d4		
		call	write_lcd4

		movf	dec9,0
		movwf	d4		
		call	write_lcd4
	;----
Adj_e	movf	new01,0		;old01=new01
		movwf	old01
		goto	Adj1
;-------------------------------
Adj595	movf	vxo,0	;VXO Adjust
		movwf	d8
		bcf		RCK		; TC74HC595 i/p
		movlw	D'8' 	;cn,#8
		movwf	cn
		
		call	writb
		rrf  	d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc	STATUS,C
		bsf		DAT		

		bcf		H59		;SCK
		bsf		H59		;SCK
		decfsz	cn,1		;djnz	cn,HC595A
		goto	HC595A
		bcf		RCK	
		bsf		RCK		;register to output latch
		return	


;------------------------------------------------------
start	bsf  	STATUS,RP0	;oN1		
		movlw	B'01110100'	;OSC=8MHz
		movwf	OSCCON
		bcf  	STATUS,RP0	;oN0

		movlw	D'255'
		movwf	wait_cn
		call	wait_ms

		bsf  	STATUS,RP0	;oN1
		movlw	B'00111111'	;RBvAbv;;INTEDG=FallEdge
		movwf	OPTION_REG	

		movlw	B'01001110'	;pinset(AN4=D,AN3=D,AN2=D,AN1=D,AN0=Analog, Vref+=5V, Vref-=GND) 
		movwf	ADCON1	;Left Justified 

		movlw	B'00100001'	;ra1,2,3,4,6,7  inputoutput
		movwf	TRISA
		bcf  	STATUS,RP0	;oN0
		clrf	PORTA

		bsf  	STATUS,RP0	;oN1
		movlw	B'00001111'	;rb.0-rb.7sin  !rb,#11111111b	
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0
		clrf	PORTB

		call	writb
		call	init_lcd		; kbc

		movlw	B'00000011'
		movwf	old01	;
		movwf	new01	;
		clrf	vxo
		clrf	VCOport
		call	readb	;rb.2-7s input mode	;d Adjvxo
st2		btfsc	PORTB,7	;if RIT=L, then Adjvxo
		goto	st4
st3		goto	Adj9	;d VXO Adjvxo

st4		call	writb
		call	TC56set			;TC9256P wakeupł
		call	TC56MD		;TC9256P wakeupł
	;	call	TC56set			;TC9256P wakeupł
	;	call	TC56LK		;PLL Lock o
	;	call	TC56MD		;TC9256P portł

		movlw	B'00011000'
		movwf	old34
		movwf	new34

		movlw	B'11110000'
		movwf	ORb27
		movlw	B'11111100'
		movwf	NRb27

		movlw	D'1'
		movwf	het

		movlw	D'128'
		movwf	O_rit		;ʏrit=128.
		movwf	N_rit

		movlw	B'00000001'
		movwf	ritSW
		call	ritChg	;setting ritSW=0

		movlw	D'200'
		movwf	step0		;;ENCD̎gstep=1(50Hz) or 10(500Hz)
		call	stp_chg		;step 200  1(50Hz)

		call	readb	;rb.2-7s input mode
		movlw	D'0'
		movwf	Nband
		call	Bnd_chg		;setting Nband=1
		
		clrf	p_chk
		clrf	nr2
		clrf	vxo	
		clrf	Tvxo
		call	TxHC595
start0		
		movlw	B'11111111'
		movwf	NRb27	;ENCD init set
		movlw	B'11110000'
		movwf	NRb27	;

		movlw	H'55'	;PLL Lock=L, else U 
		movwf	plk

		movlw	B'00000000'
		movwf	VCOport		;=o5/xx/xx/xx/ o4/o3/o2/o1, 0=High(OFF), 1=Low(ON)
		
		call	readb	;rb.2-7s input mode	;dZbg step-SW ON
st00	btfsc	PORTB,6	;if STEP=L, then reset
		goto	st05
st01	btfss	PORTB,6	;
		goto	st01
		goto	start1

st05	call	load_1st
		movlw	B'00000001'
		subwf	stROM,0	 
		btfss	STATUS,Z	;if stROM=1, then st07 & Load_m else atart1
		goto	start1

st07	call	load_m		;EEPROM #0(mode) &01h-o5hԒnload
							;stROM, vxo,	nr0,	nr1,	Nband- 5A
		movf	stROM,1	; if stROM=0, then init EEPROM save(sav_ini)
		btfss	STATUS,Z
		goto	start3

start1	movlw	B'00000001'	
		movwf	stROM ;stROM=1
		clrf	Nband
		call	Bnd_chg		;Nband 0  1(7MHz)//setting nr0, nr1, het
		bsf		p_chk,0	;in order to check VCO_Num
		call	setVCO
		clrf	vxo
		call 	sav_ini		; ̏EEPROMւ save
		goto	start35

start3 	nop		; ==Rev.1 2018.03.04==
		movlw	D'8'		;if Nband=8(50MHz), then het=D'2' else het=D'1' 
		subwf	Nband,0
		movlw	D'1'
		btfsc	STATUS,Z	; if Z=0, then het=D'2'
		movlw	D'2'	;if D'2', then Up Hetro
		movwf	het
		call	H595_Bset
		call 	setIF
		nop		; ==Rev.1 2018.03.04==

start35	call	writb
		bsf		p_chk,0	;in order to check VCO_Num
		call	setVCO
		call	RX	;;RX nr0,nr1 TC9256P ֓		
		call	TC56MD	;port PLL^Lock(OT4) set
		call	RX	;;RX nr0,nr1 TC9256P ֓
		call	TC56LK		;if PLL lock, plk=uLv=04ch, else plk=uUv=055h
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
		call	put1st
		call	put2nd
		call	readb

start4	call	writb
		call	TC56MD	;port PLL^Lock(OT4) set
S_end	movlw	B'10010000'			;GIE=1 enable, INTE=1 enable
		movwf	INTCON
		bcf		INTCON,7	;荞݋֎~ 

main	bcf		vfc,0
		btfsc	p_chk,0	;if nr1 change, then p_chk,0=1
		call	setVCO		;nr1ύX́@VCO_num	Check
main1	call	writb	;Rb.4-7 o̓|[g
		;call	TC56MD
	
		call	TC56MD	;port PLL^Lock(OT4) set
		call	RX			;TC9256P nr0, nr1 & HC595vxo
		call	TC56LK		;if PLL lock, plk=uLv=04ch, else plk=uUv=055h
	;	bcf		INTCON,7	;荞݋֎~ 
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
	;	bcf		INTCON,7	;荞݋֎~

main12	call	put1st
main15	call	put2nd
main2	;bcf		INTCON,7	;荞݋֎~ 
		bsf		INTCON,7	;荞݊Jn 

main3	btfsc	PTT	;if RA.5=L, then TX 
		goto	main36
		bcf		INTCON,7	;荞݋֎~
		call	TX	;RXTX 
main31	; TX́@PORTB.3 & 4 check
		call	chk34

main36	nop
		btfss	PTT	;if RA.5=L, then TX continue
		goto	main31
		call	RX	;;TXRX
	;----------RIT---------
main4	btfss	ritSW,0	;if RIT=Off,goto main5	//ritSW=1 or 0
		goto	main5
		goto 	Rmain1		;if RIT=On ,goto Rmain1(RIT)
	
Rmain1	;RIT
		bcf		INTCON,7	;荞݋֎~
		call	rit_ck	;rit VRʒuAcall, RXLCD2sڕ\
		call	readb		;input mode  portb
		movf	PORTB,0	
		andlw	B'11111100'

		btfsc	PTT	;if PTT=ON(L), then PORTB.5 & 6 =H mask
		goto	Rm1
		iorlw	B'01100000'
Rm1		movwf	NRb27		;NRb27portb.8-2

		btfss	ritSW,0		;Masking during RIT
		goto	Rm5
		movlw	B'01100000'	;Masking RB6<Step>ARB5<Band>A
		iorwf	NRb27,1		

Rm5		call	chk27		;RB2-7 ̓`FbN
		call	chk34
		goto	main3
	;-----------RIT end-----
main5	call	readb		;input mode portb
		bsf		INTCON,7	;荞݊Jn
main51	call	wt5u		;5 usec҂		
		btfsc	vfc,0	;
		goto	main	;
main53	call	chk34	;;RB3-4 ̓`FbN
		call	chk27		;RB2-7 ̓`FbN
				;Band, Mode, Step, Rit, ??
		bsf		INTCON,7	;荞݊Jn

	;***added for RIT
		btfsc	ritSW,0	;if RIT=ON,goto main15	//ritSW=1 or 0
		goto	main15
		goto 	main7
	;***added for RIT
main7	btfss	vfc,0	;
		goto	main51	;
		goto	main
;----------------------------
;-------------------------------
chk34	call	readb		;input mode portb	
		movf	PORTB,0		
		andlw	B'00011000'	;Rb3,4,̂ݎc
		movwf	new34	
		subwf	old34,0
		btfss	STATUS,Z	;if new34=old34, then return
		goto	setIF	;LSB,USB,CW check
		return

chk27	call	readb		;input mode portb	
		movf	PORTB,0		
		andlw	B'11111100'	;Rb2,3,4,5,6,7̂ݎc
		btfsc	PTT	;if PTT=ON(L, on TX), then PORTB.5 & 6 =H mask
		goto	chk50
		iorlw	B'01100000'		
chk50	movwf	NRb27
		movf	NRb27,0
		subwf	ORb27,0
		btfss	STATUS,Z		;if Nrb27=ORb27, then return
		goto	c27set	
		return
	
c27set	bcf		INTCON,7	;荞݋֎~
		movf	NRb27,0		;mov	old47,new47
		movwf	ORb27
	
ch1		btfss	NRb27,2		;if Rb.2=L, then Memo
		goto	Memo

ch4		btfss	NRb27,5		;if Rb.5=L, then Band_change
		goto	Bnd_chg
			
ch5		btfss	NRb27,6		;if Rb.6=L, then Step_change
		goto	stp_chg

ch6		btfss	NRb27,7		;if Rb.7=L, then RIT set
		goto	ritChg

ch27e	movlw	D'100'
		movwf	wait_cn
		call	wait_ms
		return
;-----------------------------
TX		;call	writb
		btfss	ritSW,0		; if RIT is Off, then return
		return
		bsf		STATUS,5	;oN1
		movlw	B'00001111'	;rb.4-rb.7sout  !rb,#00001111b	
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		
		call	TxHC595
		call	TX56set		;Tnr1\Tnr0 setting
		return

RX		bcf		PORTB,2		;RB2=L for RX
		call	writb	
		call	RxHC595
		call	TC56set	;nr1/nr0 setting
		return	
;--------------------------------
;----------------------------------
ritChg	movf	ritSW,0	;ritSW	=1 or 0	
		btfss	STATUS,Z
		goto	r_off
		goto	r_on	
	
r_on	movf	nr0,0	;RIT TX́@nrޔTnr
		movwf	Tnr0
		movf	nr1,0
		movwf	Tnr1
		movf	vxo,0
		movwf	Tvxo

		bsf		ritSW,0
		;s_rit		;24hԒnBRIT+(2b )-( 2d)H 
		;decrit0	;25hԒnBRIT̕΍(100HzP)10iϊBLCD\p
		;decrit1	;26hԒnBRIT̕΍(100HzP
		;decrit2	;26hԒnBRIT̕΍(100HzP
		;dot		;27hԒn.RIT\̐Ԃ̃hbg"."
		movlw	H'2E'	;Chara "."
		movwf	dot

rit_ck	call	adloop	;RA0 50kVR (0-255)@N_ritɎ荞
		movf	N_rit,0
		subwf	O_rit,0
		btfsc	STATUS,Z
		return			;if N_rit=O_rit, return
		goto	rit_c1

rit_c1	movf	Tnr0,0	;Tnrޔback to nr 
		movwf	nr0
		movf	Tnr1,0
		movwf	nr1
		movf	Tvxo,0
		movwf	vxo

		movf	N_rit,0
		movwf	x0
		movlw	D'128'
		subwf	x0,0		;W=x0 +(256-128)

		btfsc	STATUS,C	;W=x0 +(256-128); if rit<128, then "-"
		goto	R_plus
		goto	R_minus	

R_plus	movlw	H'2b'	;RIT"+"(2bh)
		movwf	s_rit
		movlw	D'128'
		subwf	x0,0 	;W= x0+(256-128)
		movwf	x0		;x0= x0-128
		movwf	step0
		call	add_v
		goto	r_div

R_minus	movlw	H'2d'	;RIT"-"(2dh)
		movwf	s_rit
		movf	x0,0
		sublw	D'128' ;W=128+ (256-W)	
		movwf	x0		;x0= 128-x0
		movwf	step0
		call	sub_v
		goto	r_div

r_div	call	RxHC595	;vxo HC595P 
		call	TC56set	;nr TC9256P

		movf	step0,0	
		movwf	val0		
		bcf		STATUS,C	
		rrf		val0,1		

		call 	dc_rit	;16i@10i
		movf	N_rit,0
		movwf	O_rit	;N_rit,O_rit
		goto	rend
	;----
r_off	bcf		ritSW,0	;ritSW=0 
		movlw	H'20'	;Chara "_"
		movwf	s_rit
		movlw	H'4F'	;Chara "O"
		movwf	decrit0
		movlw	H'46'	;Chara "F"
		movwf	dot
		movlw	H'46'	;Chara "F"
		movwf	decrit1
		movlw	H'20'	;Chara "_"
		movwf	decrit2

		movf	Tnr0,0	;Tnrޔback to nr 
		movwf	nr0
		movf	Tnr1,0
		movwf	nr1
		movf	Tvxo,0
		movwf	vxo
		call	st50	;step=1 (50Hz)

		movlw	D'128'	; RIT=128
		movwf	O_rit
		goto	rend
	;----	
rend	call	put_rit		;RITύX\
		goto	ch27e
	;	;return				
;-------------------
;	RIT;A/DϊJn@@AN0|[g@AiO	
adloop	movlw	B'01000001'	;set AD_channel=AN0, conversion_clock=16Tosc, )  
		movwf	ADCON0

		movlw	D'25'		;acquisition time wait 25usec
		movwf 	wait_cn	
		call	wait_us 

		bsf  	ADCON0,GO
ad_pol		
		nop  
		btfsc	ADCON0,GO
		goto	ad_pol		;AD conv polling
		movf	ADRESH,0
		movwf	N_rit		;ADϊLeft Justified@rit荞݁@(0-255)
		bcf  	ADCON0,0	;AD OFF
		bcf  	ADCON0,GO	;AD conv reset
		return
;--------------------------------
stp_chg		;    50Hz(step=1)	10kHz(step=200)
		movf	step0,0
		sublw	D'1'
		btfsc	STATUS,Z
		goto	st10k
		goto	st50

st50	movlw	D'1'
		movwf	step0

		movlw	H'35'	; steplƂ50H(35h, 30h, 48h)/Chara "5"
		movwf	Dstep0
		movlw	H'30'	;Chara "0"
		movwf	Dstep1
		movlw	H'48'	;Chara "H"
		movwf	Dstep2
		goto	stend

st10k	movlw	D'200'
		movwf	step0

		movlw	H'31'	; steplƂ10k(31h, 30h, 6Bh)/Chara "1"
		movwf	Dstep0
		movlw	H'30'	;Chara "0"
		movwf	Dstep1
		movlw	H'6B'	;Chara "k"
		movwf	Dstep2
		goto	stend	
stend	call	put2nd		;stepύX\
		goto	ch27e
	;	;return
;----------------------------
Bnd_chg		;3.5, 7, 10,14,18,21,24.5,28,50MHz		
			; 0 , 1 , 2, 3, 4, 5,   6, 7, 8 =Nband
		incf	Nband,1	;Nband= Nband+1 (0<= Nband <=8)
		movf	Nband,0
		sublw	D'9'
		movlw	D'0'	
		btfss	STATUS,Z
		movf	Nband,0
		movwf	Nband
		goto	setBand	;setting nr0, nr1, het
		;return
;----------------------------
setBand	;NbandĂ	;set nr0,nr1 & het
		; "B_data" callƂɁAW=Nband Ƃ邱ƁB@0=< Nband@<=8
		movf	Nband,0
		andlw	B'00001111'
		call	B_data ;;setting nr0,nr1 & het
		call	H595_Bset

		clrf	vxo		;2018.05.06
		bsf		p_chk,0	;if nr1 change, then p_chk,0=1
		goto	setIF
	;	;return
;--------------------------------------------------------
;-------------------------------------------------------	
setIF	movf	new34,0		;mov	old47,new47
		movwf	old34
		call	VXOset		; x@ VXO 	;;VXOg@@ɓ;
						;;.VXOmin=62,815.0kHz=H'0995B6'

		nop		;RB3, 4H/LɂACW,USB,LSB IFZbg @y
		call	IFset	;;y@IF 100HzPʂŎgdata

		btfss	het,0	;;/	up=1; lower=2
		goto	sIF2 ;Lower hetro
		goto	sIF1	;Upperer hetro

sIF1	call	add_xy	;(32bit)(32bit){y(32bit) ;if=VXO(62MHz)+IF(12MHz)
		goto	sIF3
sIF2	call	sub_xy	;(32bit)(32bit)- y(32bit) ;if=VXO-IF
		goto	sIF3

sIF3	movf	x0,0
		movwf	if0	
		movf	x1,0
		movwf	if1
		movf	x2,0
		movwf	if2
	
		goto	Dmode
		;return

Dmode 	btfss	new34,3
		goto	Dcw
		btfss	het,0		;;/	up=1; lower=2
		goto	Dh_2
		goto	Dh_1
		nop
Dh_1	btfss	new34,4	;Normal
		goto	Dusb
		goto	Dlsb

Dh_2	btfsc	new34,4	;Reveasal
		goto	Dusb
		goto	Dlsb

Dcw		movlw	H'20'	;Chara "_"
		movwf	USB0
		movlw	H'43'	;Chara "C"
		movwf	USB1
		movlw	H'57'	;Chara "W"
		movwf	USB2
		goto	D_end

Dlsb	movlw	H'4C'	;Chara "L"
		movwf	USB0
		movlw	H'53'	;Chara "S"
		movwf	USB1
		movlw	H'42'	;Chara "B"
		movwf	USB2
		goto	D_end

Dusb	movlw	H'55'	;Chara "U"
		movwf	USB0
		movlw	H'53'	;Chara "S"
		movwf	USB1
		movlw	H'42'	;Chara "B"
		movwf	USB2
		goto	D_end

D_end	bcf		INTCON,7	;荞݋֎~
		call	setVCO		;nr1ύX́@VCO_num	Check 
		call	RX
		call	writb
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
		bcf		INTCON,7	;荞݋֎~ 
		call	put1st
		call	put2nd
		goto	ch27e
	;	;return
;------------------
setVCO	btfss	p_chk,0
		return

		bcf		p_chk,0
		clrf	poi
		movlw	D'3'
		movwf	cn
setV1	movf	poi,0
		call	VCO_Nr1
		movwf	x0	;temp VCO_nr1
		subwf	nr1,0	;W=nr1 +(256- VCO_nr1)
		btfss	STATUS,C	;if nr1 < VCO_nr1, then C=0 & goto setV2
		goto	setV2
		incf	poi,1
		decfsz	cn,1
		goto	setV1 
	;	return
setV2	movf	poi,0
		call	VCO_set	;VCO port of TC9256P
		movwf	VCOport

		movf	poi,0
		call	VCOname	;;VCO name ?A/B/C/D@VCO_n
		movwf	VCO_n
	;	;return

		call	TC56MD	;;VCOύX VCO port set
		return
;------------------
TX56set	movf	Tnr0,0	;PLL @nr1, nr0
		movwf	x0
		movf	Tnr1,0
		movwf	x1
		goto	TC56FR

TC56set	movf	nr0,0	;PLL @nr1, nr0
		movwf	x0
		movf	nr1,0
		movwf	x1
	
TC56FR		;VCO A,B,C,D Iʒux̂߁Anr0, nr1 *S{setĂ̂ŁA߂
		bcf		STATUS,C
		rrf		x1,1	;nr=nr* 1/2
		rrf		x0,1

		bcf		STATUS,C
		rrf		x1,1	;nr=nr* 1/4
		rrf		x0,1

		movlw	H'D0'	;mov	d8,#0d0h		;gύX
		movwf	d8
		movlw	B'10011001'
		movwf	x2
		;mov	x[2],#10011001b		;OSC2/OSC1/Mode/FM/  R3/R2/R1/R0=10 01 1001b
		goto	TC56in			;  	OSC=7.2MHz, FML, fref=9kHz (ref=10kHz@8MHz)

TC56MD	movlw	H'D2'	;mov	d8,#0d2h		;VCOύXA 
		movwf	d8
		movlw	B'10100000'	
		movwf	x0		;mov	x[0],#10100000b	
						;reset/DOHZ/CLK/IF2/IF1/SC/G1/G0
						;1UL  /0   /1  /0  /0  /0 /0--0
		movlw	B'01001010'	
		movwf	x1		;mov	x[1],#01001010b		
						;o1 /M6 /M5 /x /x /XT /TEST/Start/xx	
						; /0  /1  /0 /0 /1  /0   /1    /0    /xx@	
						;Start=counter start bit, Reset=Unlock reset_bit
						;rrf1bitEւ;#1bit=start bit
		movlw	H'4c'		;if PLL lock, then plk=uLv=04ch,
		subwf	plk,0
		movlw	B'00000000'
		btfsc	STATUS,Z	;if plk=uLv=04ch,
		movlw	B'00001000'	;port o4="h" ;1

		xorwf	VCOport,0		;=o5/xx/xx/xx/ o4/o3/o2/o1, 0=High(OFF), 1=Low(ON)
		andlw	B'00001111'
		movwf	x2		;mov	x[2],OT		
						;o6/o5/xx/xx/xx/ o4/o3/o2/o1
						;x /x /x /x /x / 0 /0 /0 /0
						;rrf1bitEւ;0bito1(OT-1)́Ax[1].7ֈړ
		bcf		STATUS,C
		rrf		x2,1		;OT.0 x[1],7Ɉړ
		rrf		x1,1
TC56in	call	writb
		bsf		PRD		;PERIOD=g
		bsf		T56		;Clock=H
		bsf		DAT		;Data=H
		nop
		movlw	D'32'	;mov	cn,#32
		movwf	cn
		bcf		PRD
TC57in	rrf		x2,1
		rrf		x1,1
		rrf		x0,1
		rrf		d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc 	STATUS,C
		bsf		DAT

		bcf		T56		;ǂݍ
		nop		;ێ1secȏ
		nop
		bsf		T56		;NbNŃf[^L
		nop		;ێ1secȏ
		nop
		bsf		PRD		;PERIOD=g
		decfsz	cn,1	;	djnz	cn,TC57in
		goto	TC57in

		bcf		PRD
		nop
		nop
		bsf		PRD
		return
;--------------------------------------------------------
TC56LK	movlw	H'D3'		;mov	d8,#0d3h		;PLL locko
		movwf	d8		
TC56out	call	writb
		bsf		PRD		;PERIOD=g
		bsf		T56		;Clock=H
		bsf		DAT		;Data=H
		movlw	D'8'	;mov	cn,#8
		movwf	cn
		bcf		PRD
TC58out	rrf		d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc 	STATUS,C
		bsf		DAT

		bcf		T56		;ǂݍ
		nop		;ێ1secȏ
		nop
		bsf		T56		;NbNŃf[^L
		nop		;ێ1secȏ
		nop
		bsf		PRD
		decfsz	cn,1	;djnz	cn,TC58out
		goto	TC58out

		bsf		STATUS,RP0	;oN1
		bsf		TRISB,7		; Rb7sIN
		bcf		STATUS,RP0	;oN0

		movlw	D'24'	;mov	cn,#24
		movwf	cn
TC60out	bcf		T56		;M󂯎ck
		nop		;Wait 1usec
		nop
		bsf		T56		;ckオŗL
		btfss	DAT
		bcf		STATUS,C	
		btfsc	DAT
		bsf		STATUS,C	
		
		rrf		y2,1		;Mf[^ y[2],7 ɓ
		rrf		y1,1
		rrf		y0,1
		decfsz	cn,1	;djnz	cn,TC60out
		goto	TC60out
		bcf		PRD
		nop	;ێ1secȏ
		nop
		bsf		PRD
		
;		btfss 	y0,0		;TC9256P UL bit EnableƂȂȂ
;		goto	TC56out		;̃[`甲oȂII
;		btfsc 	y[2],5
;		goto	TC56out

;TC61		movlw	00001111b
;		andwf	y[2],1 	

		bsf		STATUS,RP0	;oN1
		bcf		TRISB,7		; Rb6sout ??
		bcf		STATUS,RP0	;oN0

		movlw	H'4c'		;if PLL lock, then plk=uLv=04ch,
		btfsc	y0,1		;PLL lock1bit=0
		movlw	H'55'		;if PLL-UNLock, then  plk=uUv=055h
		movwf	plk
		return
;-------------------------------------
TxHC595	movf	Tvxo,0	;VXO tuning voltage
		;sublw	D'199'		;//W=199+ (256-vxo);]
		movwf	d8
		bcf		RCK		; TC74HC595 i/p
		movlw	D'8' 	;cn,#8
		movwf	cn
		goto	HC595A

RxHC595	movf	vxo,0	;VXO tuning voltage
	;	sublw	D'199'		;//W=199+ (256-vxo)G]
		movwf	d8
		bcf		RCK		; TC74HC595 i/p
		movlw	D'8' 	;cn,#8
		movwf	cn
HC595A	call	writb
		rrf  	d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc	STATUS,C
		bsf		DAT		

		bcf		H59		;SCK
		bsf		H59		;SCK
		decfsz	cn,1		;djnz	cn,HC595A
		goto	HC595A
		bcf		RCK	
		bsf		RCK		;register to output latch
		return	

;-----------------
H595_Bset	;H595(3rd)Band sel SW̐ݒ
		movlw	B'00000001'
		movwf	d8
		bcf		STATUS,C
		movf	Nband,0
		btfsc	STATUS,Z
		goto	H595_B3

		movf	Nband,0
		movwf	cn
H595_B1	bcf		STATUS,C
		rlf		d8,1
		decfsz	cn,1		;djnz	cn,H595_B1
		goto	H595_B1	

H595_B3	movlw	D'8' 	;cn,#8
		movwf	cn
HC595C	call	writb
		rlf  	d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc	STATUS,C
		bsf		DAT		

		bcf		H59_3		;SCK
		bsf		H59_3		;SCK
		decfsz	cn,1		;djnz	cn,HC595C
		goto	HC595C
		bcf		RCK	
		bsf		RCK		;register to output latch

		movlw	D'8'		;if Nband=8, then SCK=H else SCK=L 
		subwf	Nband,0
		btfss	STATUS,Z
		bcf		H59_3		;SCK
		nop
		return

;------------------------------		
putfre	; 5000step/
			;Upper Hetero  f(100HzP)=(nr-1) x100- [(62,825.0kHz+IF) -vxo/2 ]
			;Lower Hetero  f(100HzP)=(nr-1) x100- [(62,825.0kHz-IF) -vxo/2 ]
					;	ȉ IF=<(62,825.0kHz+IF)> or <(62,825.0kHz-IF)>
		movf	if0,0
		movwf	x0
		movf	if1,0
		movwf	x1	
		movf	if2,0
		movwf	x2
		;clrf	x3

		movf	vxo,0
		;sublw	D'199'	;W=199+ (256-vxo)
		movwf	y0
		bcf		STATUS,C
		rrf		y0,1	;y0=1/2 *vxo
		call	sub_xy8	;(24bit)(24bit)-y(8bit)@//IF= IF - vxo/2

		movf	x0,0
		movwf	y0
		movf	x1,0
		movwf	y1	
		movf	x2,0
		movwf	y2
		;clrf	y3		

		movf	nr0,0
		movwf	val0
		movf	nr1,0
		movwf	val1

		movlw	D'25'	;x= (nr1+nr) * 2.5kHz
		movwf	N
		clrf	val2
		call	mult_vN	;	;x[32bit]=val[24bit] * N[8bit]

		call	sub_xy	;(24bit)(24bit)|y(24bit)//=Nr x100 -( IF - vxo/2)
		
pf3		movf	x0,0	
		movwf	val0
		movf	x1,0	
		movwf	val1
		movf	x2,0	
		movwf	val2		
	;	movf	x3,0	
	;	movwf	val3	

		call	dcmain		;16i-10iϊ	/4900step	
		return
;--------------------
put1st		; 590step+680us
		call	writb				;/8step
		clrf	poi	;tab_dp(LCD)1Ԗڕ\
		movlw	H'80'
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		movlw	D'16'			;mov	cn,#16	;16
		movwf	cn
		goto	dp_bun

put2nd		; 580step+680us
		call	writb				;/8step
		movlw	D'16'	;tab_dp(LCD)16Ԗ=LCD2s1\
		movwf	poi
		movlw	H'c0'	;cursol 2s
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		movlw	D'16'			;mov	cn,#16	;16
		movwf	cn
		goto	dp_bun

put_rit		; 580step+680us
		call	writb				;/8step
		movlw	D'28'	;tab_dp(LCD)28Ԗ=LCD2s13\
		movwf	poi
		movlw	H'cc'	;cursol 2s13
		movwf	d4
		bcf		RS		;cursorʒu 
		movlw	D'4'			;mov	cn,#4	;4
		movwf	cn
		call	write_lcd4			;/20step+40us
		goto	dp_bun
;-------;\郋[`	;\X^ĆAtab_dpɑΉ	;poi=ʒuA0<=poi<tab_dpmaxl
dp_bun		;\				;/16x(35step+40us)=560step+640us
		bsf		RS
dpb1	movf	poi,0
		call	tab_dp
		movwf	d4
		btfsc	d4,7		;if d4.7=1, then dpb4
		goto	dpb4
		;goto	dpb3
dpb3	movwf	FSR		;WX^[AhX
		movf	INDF,0
		movwf	d4
		goto	dpb5			

dpb4	bcf		d4,7		;d4ɑΉ镶
dpb5	call	write_lcd4	;
		incf	poi,1
		decfsz	cn,1
		goto	dpb1
		return
;--------------------------------------------------
readb	bsf		STATUS,RP0	;oN1	;rb.2-7s input mode
		movlw	B'11111111'	;rb.0-7sin  !rb,#11111111b
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		clrf	PORTB
		return

;---------
writb	bsf		STATUS,RP0	;oN1
		movlw	B'00001011'	;rb2 & rb.4-rb.7sout  	
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		return
;----------------
;		t[`
init_lcd
		bcf		RS			; RS='L'	
		movlw	B'00110000'	;mov	d8,#00110000b
		movwf	d8
		call	write_lcd8
		call	wait_20			; wait 4.1msȏ

		movlw	B'00110000'	;mov	d8,#00110000b
		movwf	d8
		call	write_lcd8
		call	wait_20			; wait 100usȏ

		movlw	B'00100000'		;mov	d8,#00100000b
		movwf	d8
		call	write_lcd8		; 0 0 0010 (4bit)
		
		movlw	B'00101000'	;mov	d4,#00101000b	; duty,font set9:Function set
		movwf	d4		
		call	write_lcd4

		movlw	B'00001000'		;mov	d4,#00001000b		; display off
		movwf	d4
		call	write_lcd4		

		movlw	B'00000001'		;mov	d4,#00000001b	; NAR}h:Clear Display
		movwf	d4
		call	write_lcd4
		call	wait_20		; NAI܂ő҂ Q0mbȏ
		
		movlw	B'00000110'		;mov	d4,#00000110b		; entry mode set
		movwf	d4
		call	write_lcd4

		movlw	B'00001110'	;mov	d4,#00001110b		; display on,cursor on
		movwf	d4
		call	write_lcd4
		return
;		Srbg[hptCg[`
write_lcd4
		movf	d4,0	;mov	d8,d4
		movwf	d8
		call	write_lcd8		;4ޯ
		
		movf	d4,0		;mov	d8,d4
		movwf	d8
		swapf	d8,1
		call	write_lcd8		;ʂSޯ
		return
;
;		Wrbg[hptCg[`
init_1	movlw	B'00110000'	;mov	d8,#00110000b
		movwf	d8
;
write_lcd8	
		clrf	cs
		rlf		d8,1		;;d8.7cs.0
		rrf		cs,1
		rlf		d8,1		;d8.6cs.1
		rrf		cs,1
		rlf		d8,1		;;d8.5cs.2
		rrf		cs,1		
		rlf		d8,1		 ;d8.4cs.3W
		rrf		cs,0
		andlw	B'11110000'
		movwf	PORTB		; Wqa|[g֏o
		bsf		E			; ds'H'
		nop
		bcf		E

		movlw	D'40'	;wait 40sec
		movwf	wait_cn
		call	wait_us
		return
;---------------------------------------------------------------------------------
;		I[_[̃EFCg
;
wait_255
		movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_ms

wt15ms	movlw	D'15'	;mov	wait_cn,#15
		movwf	wait_cn
		goto	wait_ms

wt4ms	movlw	D'4'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt1ms	movlw	D'1'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt255u	movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_us

wt5u	movlw	D'5'	;mov	wait_cn,#5
		movwf	wait_cn
		goto	wait_us

wait_20	movlw	D'20'		;mov	wait_cn,#20
		movwf	wait_cn
wait_ms  	
wait_ms0	
		movlw	D'0'	;mov	wait_cn2,#0
		movwf	wait_cn2
wait_ms1
		movlw	2	
		movwf	cp
wait_ms2
		nop
		decfsz	cp,1
		goto	wait_ms2		
		decfsz	wait_cn2,1
		goto	wait_ms1	;djnz	wait_cn2,wait_ms1

		decfsz	wait_cn,1
		goto	wait_ms0	;djnz	,
		return
;
;		ʂI[_[̃EFCg
;
wait_us		
wait_us0
		decfsz	wait_cn,1	;djnz	wait_cn,wait_us0
		goto	wait_us0
		return
;	---------------	end of lcd.asm
;    ---------------------------------------------------
load_1st
		movlw	H'0'
		movwf	ADDR
		movlw	D'1'      
		movwf	scn

		movlw	stROM   ;stROM, vxo,nr0,nr1,Nband- 5address  
		movwf	FSR
		goto	load_rt
;	;------------------------
;		;#00h   #01h    #02h    #03h	#04h	#05h	#06h	#07h
;		;stROM, vxo,	nr0,	nr1,	Nband- 5Aaddress	
load_m	movlw	H'0'
		movwf	ADDR
		movlw	D'5'      
		movwf	scn

		movlw	stROM   ;stROM, vxo,nr0,nr1,Nband- 5address  
		movwf	FSR
load_rt	bcf		STATUS,RP0	;Bank2/Select Bank of EEADR
		bsf		STATUS,RP1	;Bank2/
		
		movf	ADDR,0      	;EEPROM address 0&h
		movwf	EEADR		; Data Memory Address to read

		bsf		STATUS,RP0		;Bank3/	Select Bank of EECON1
		bcf		EECON1,EEPGD	; Select Bank of EECON1
		bsf		EECON1,RD		; EE Read

		bcf		STATUS,RP0		;Bank2/ Select Bank of EEDATA
		movf	EEDATA,0      
		movwf	INDF

		incf	ADDR,1
		incf	FSR,1
		decfsz	scn,1
		goto	load_rt

		bcf		STATUS,RP0	;Bank0
		bcf		STATUS,RP1
		return
;    ------------------------------------
Memo
sav_ini		;
		movlw	H'0'
		movwf	ADDR
		movlw	D'5'      
		movwf	scn

		movlw	stROM   ;stROM, vxo,nr0,nr1,Nband- 5Aaddress
		movwf	FSR
sav_i5	movf	INDF,W
		movwf	VALUE
		call	datawrite
		incf	ADDR,1
		incf	FSR,1
		decfsz	scn,1
		goto	sav_i5
		goto	ch27e
	;	;return
;   ----------------------------------------		
datawrite	
		bsf		STATUS,RP0	;Bank3
		bsf		STATUS,RP1	;Bank3/	Select Bank of EECON1

	;	bcf		EECON1,WR
dr1		btfsc	EECON1,WR	;Wait for write to complete
		goto	dr1

		bcf		STATUS,RP0	;Bank2/Select Bank of EEADR
		movf	ADDR,W
		movwf	EEADR		;Data Memory Address to write

		movf 	VALUE,W  	;
		movwf	EEDATA 		; Data Memory Value to write

		bsf		STATUS,RP0	;Bank3/	Select Bank of EECON1
		bcf		EECON1,EEPGD	;; Point to DATAmemory 	
		bsf		EECON1,WREN		;WRENޯ on; Enable writes

		bcf		INTCON,GIE 		; Disable INTs
	;-----
		movlw	H'55'
		movwf	EECON2
		movlw	H'aa'
		movwf	EECON2
		bsf		EECON1,WR 		; Set WR bit to begin write
	;-----
		bsf		INTCON,GIE 		; Enable INTs.
		bcf		EECON1,WREN 	; Disable writes

		call	wt15ms		; wait 15ms
		bcf		STATUS,RP0	;Bank0
		bcf		STATUS,RP1
		return
;***********************************************************************
;---------------------
;	8rbgoCiPOiϊ
;	val08rbgf[^uB val0<99
dc_rit	movlw	decrit1		;; i[ꏊl
		movwf	FSR
		incf	FSR,1
		call	devi			; ŉʕϊ 
		call	devi			;2JԂ
		return

devi	movlw	D'8'		;mov	cn,#8			; 8rbgԂ
		movwf	cn
		clrf	val_m
devi0		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devi0

		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	INDF
		return

;---------------------------------------------------------------------
;	24rbgoCiPOiϊ
;
;	val24rbgf[^uBi:val[2]:val[1]:va[0])
;
;	dcmainR[B
;
;	decɓi[B
;		(dec[2]:dec[3]:...:dec[8]:dec[9])
;		dec[2]ŏʌdec[9]ŉʌłB
;
;	ϊval͔j󂳂B
;
;	sample:
;		val	= 00:00:04:D2 h
;		dec	= 00:00:00:00:00:00:01:02:03:04
;                  dec(0):dec(1):(2):(3):(4):(5):(6):(7):(8):dec(9)
;						(1,234)
;
dcmain
		movlw	dec9		;;mov	fsr,#dec_top	; i[ꏊl
		movwf	FSR
		incf	FSR,1
		call	devide			; ŉʕϊ 
		call	devide			;10JԂ
	;	call	devide
	;	call	devide
		call	devide

		call	devide
dcm1	call	devide
		call	devide
		call	devide
		call	devide			; ŏʕϊ
		
zeroblank
		movlw	D'5'		;**.*MHz\̑2܂blank\
		movwf	cn			;Zero Blanku

		movlw	dec2	;movlw  dec0	;; dec[0]i[ꏊl
		movwf	FSR
zb1		movlw	B'00110000'
		subwf	INDF,0
		btfss	STATUS,Z		;if dec[]=00, then continue, else return
		goto	zb3
zb2			;if dec[]=00, then dec[]=0ehł́Ablank \ƂȂ
		movlw	H'20'	;Letter'_'
		movwf	INDF	;movwf	indirect

		incf	FSR,1
		decfsz	cn,1
		goto	zb1

zb3		movf	Nband,0
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	dec0
		return

;
;		POTu[`
;		POŏZ܂
;
devide		
		movlw	D'32'		;mov	cn,#32			; RQrbgԂ
		movwf	cn
		clrf	val_m
devide0		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devide0

		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	INDF
		return
;----------------------------------------end of 10iϊ	
;	Z		(24bit)(24bit)|y(8bit)@
sub_xy8
		movf	y0,0				;sub	x[0],y[0]
		subwf	x0,1
		movlw	1
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1
	;	btfss	STATUS,C
	;	subwf	x3,1
		return

;-----------------------
;	Z		(24bit)(24bit)|y(24bit)@
sub_xy
		movf	y0,0				;sub	x[0],y[0]
		subwf	x0,1
		movlw	1
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1
	;	btfss	STATUS,C
	;	subwf	x3,1

		movf	y1,0				;sub	x[1],y[1];
		subwf	x1,1
		movlw	1
		btfss	STATUS,C
		subwf	x2,1
	;	btfss	STATUS,C
	;	subwf	x3,1

		movf	y2,0				;sub	x[2],y[2];
		subwf	x2,1		
								
	;	movlw	1
	;	btfss	STATUS,C
	;	subwf	x3,1
		
	;	movf	y3,0				;sub	x[3],y[3]
	;	subwf	x3,1								
		return
;--------------------------------------------------------------------
; 	Z	(24bit)(24bit){y(8bit)@
;
add_xy8				
		movf	y0,0				;add	x[0],y[0]
		addwf	x0,1
		movlw	1
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
	;	btfsc	STATUS,C
	;	addwf	x3,1
		return
;------------------------------------
; 	Z	(24bit)(24bit){y(24bit)@
;
add_xy				
		movf	y0,0				;add	x[0],y[0]
		addwf	x0,1
		movlw	1
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
	;	btfsc	STATUS,C
	;	addwf	x3,1
		
		movf	y1,0				;add	x[1],y[1]
		addwf	x1,1
								
		movlw	1
		btfsc	STATUS,C
		addwf	x2,1
	;	btfsc	STATUS,C
	;	addwf	x3,1
		
		movf	y2,0				;add	x[2],y[2]	]
		addwf	x2,1
							
	;	movlw	1
	;	btfsc	STATUS,C
	;	addwf	x3,1

	;	movf	y3,0				;add	x[3],y[3]
	;	addwf	x3,1		
								
		return
;-----------------------------------------------------------------------
;	|Z		x[32bit]=val[24bit] * N[8bit]
;
;	nr 24rbgf[^uB
;		i:val[2]:val[1]:val[0]) 	vZߒ val_m g
;       N 8ޯްuB
;                 N ;  ő  #255łB
;
;	xɓi[B
;                ix[3]:x[2]:x[1]:x[0]) 
;       		
;	ϊ N ͔j󂳂ȂB
;
;
mult_vN	clrf		x3
		clrf		x2
		clrf		x1
		clrf		x0
		clrf		val_m			;ǉ1
			
		movlw 	D'8'
		movwf 	cn
mult0		
		btfss	N,0
		goto	mutpas

		movf	val0,0				;add	x[0],step[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	val1,0				;add	x[1],step[1]
		addwf	x1,1		
									
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	val2,0				;add	x[2],step[2]	
		addwf	x2,1		
									
mutpas	bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val_m,1		;ǉ1
		btfsc	STATUS,C
		bsf		val0,0

		bcf		STATUS,C
		rrf		N,1
		btfsc	STATUS,C
		bsf		N,7

		decfsz	cn,1			;	djnz	cn,mult0
		goto	mult0

		movlw	D'8'
		movwf	cn
multrot	bcf		STATUS,C
		rrf		val_m,1				;ǉ1
		rrf		val2,1
		rrf		val1,1
		rrf		val0,1
	;	btfsc	STATUS,C
	;	bsf		val3,7
		decfsz	cn,1			;djnz	cn,multrot
		goto 	multrot
		return
;---------------------------end of |Z
;-----------------------------------------------------
;	32rbgoCiZTu[`
;		val<32bit> = x<32bit> / y<16bit>; 
;
;	x 32 rbgf[^u܂B
;		ix[3]:x[2]:x[1]:x[0]) 
;       y 16ޯްu܂B
;              y[1]:y[0];  ő  H'FFFF'łB
;
;	val ɓi[܂B
;                ival[3]:val[2]:val[1]:val[0])  ]x[1][0]
;	vZ̉ߒ	Z		(32bit)(32bit)|y(32bit)gp
;       vZ̉ߒval[3]-val[0]Aval[0] ĝŒ`KvłB
;		
;
Div_xYY
		movf	y1,0		;y=y *256*256
		movwf	y3
		movf	y0,0
		movwf	y2
		clrf	y1
		clrf	y0
		movlw	D'17'			
		movwf	cn
		movlw	D'16'			
		movwf	cs
		clrf	val0
		clrf	val1
		clrf	val2
		clrf	val3

Dv1		movf	cs,1
		btfsc	STATUS,Z	;if y=0, can't divided then return
		return	
		btfsc	y3,7	;if y3.7 =0, then y rotate
		goto	Dv2
		bcf		STATUS,C
		rlf		y2,1
		rlf		y3,1
		incf	cn,1
		decfsz	cs,1
		goto 	Dv1		
				
Dv2		;;x>=y ? check
		movf	x3,0
		subwf	y3,0		; W=y3+ (256-x3)
		btfss	STATUS,C	; if y3<x3, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y3>x3, then Dv4
		goto	Dv4

		movf	x2,0
		subwf	y2,0		; W=y2+ (256-x2)
		btfss	STATUS,C	; if y2<x2, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y2>x2, then Dv4
		goto	Dv4

		movf	x1,0
		subwf	y1,0		; W=y1+ (256-x1)
		btfss	STATUS,C	; if y1<x1, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y1>x1, then Dv4
		goto	Dv4

		movf	x0,0
		subwf	y0,0		; W=y0+ (256-x0)
		btfss	STATUS,C	; if y0<x0, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y0>x0, then Dv4
		goto	Dv4
		goto	Dv3

Dv3		;x>=y@Ȃ̂ňZ
		call 	sub_xy	;(32bit)(32bit)|y(32bit)
		bsf		STATUS,C	
		goto	Dv5

Dv4		;x<y Ȃ̂ 
		bcf		STATUS,C	
Dv5		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1	
		decfsz	cn,1		
		goto	Dv6
		return
Dv6		bcf		STATUS,C
		rrf		y3,1	
		rrf		y2,1
		rrf		y1,1	
		rrf		y0,1
		goto	Dv2
	;=============================
      END                       ; directive 'end of program'
